Index: /trunk/src/VBox/Devices/Audio/AudioMixer.cpp
===================================================================
--- /trunk/src/VBox/Devices/Audio/AudioMixer.cpp	(revision 73407)
+++ /trunk/src/VBox/Devices/Audio/AudioMixer.cpp	(revision 73408)
@@ -657,5 +657,5 @@
     if (RT_SUCCESS(rc))
     {
-        rc = RTCircBufCreate(&pMixStream->pCircBuf, DrvAudioHlpMsToBytes(100 /* ms */, &pSink->PCMProps)); /** @todo Make this configurable. */
+        rc = RTCircBufCreate(&pMixStream->pCircBuf, DrvAudioHlpMilliToBytes(100 /* ms */, &pSink->PCMProps)); /** @todo Make this configurable. */
         AssertRC(rc);
     }
@@ -931,5 +931,5 @@
 #else
         /* Return how much data we expect since the last write. */
-        cbWritable = DrvAudioHlpMsToBytes(RTTimeMilliTS() - pSink->tsLastReadWrittenMs, &pSink->PCMProps);
+        cbWritable = DrvAudioHlpMilliToBytes(RTTimeMilliTS() - pSink->tsLastReadWrittenMs, &pSink->PCMProps);
 #endif
     }
Index: /trunk/src/VBox/Devices/Audio/DrvAudio.cpp
===================================================================
--- /trunk/src/VBox/Devices/Audio/DrvAudio.cpp	(revision 73407)
+++ /trunk/src/VBox/Devices/Audio/DrvAudio.cpp	(revision 73408)
@@ -667,10 +667,10 @@
 
     /* If no own pre-buffer is set, let the backend choose. */
-    uint32_t msPreBuf = DrvAudioHlpFramesToMs(CfgHostAcq.Backend.cfPreBuf, &pCfgHost->Props);
+    uint32_t msPreBuf = DrvAudioHlpFramesToMilli(CfgHostAcq.Backend.cfPreBuf, &pCfgHost->Props);
     LogRel2(("Audio: Pre-buffering size of stream '%s' is %RU32ms (%RU32 frames)\n",
              pHstStream->szName, msPreBuf, CfgHostAcq.Backend.cfPreBuf));
 
     /* Make sure the configured buffer size by the backend at least can hold the configured latency. */
-    const uint32_t msPeriod = DrvAudioHlpFramesToMs(CfgHostAcq.Backend.cfPeriod, &pCfgHost->Props);
+    const uint32_t msPeriod = DrvAudioHlpFramesToMilli(CfgHostAcq.Backend.cfPeriod, &pCfgHost->Props);
 
     LogRel2(("Audio: Period size of stream '%s' is %RU32ms (%RU32 frames)\n",
@@ -685,5 +685,5 @@
     }
 
-    uint32_t msBufferSize = DrvAudioHlpFramesToMs(CfgHostAcq.Backend.cfBufferSize, &pCfgHost->Props);
+    uint32_t msBufferSize = DrvAudioHlpFramesToMilli(CfgHostAcq.Backend.cfBufferSize, &pCfgHost->Props);
 
     LogRel2(("Audio: Buffer size of stream '%s' is %RU32ms (%RU32 frames)\n",
@@ -1044,6 +1044,6 @@
             {
                 Log3Func(("[%s] Buffer: Last written %RU64ms, writing %RU32 frames (%RU64ms), now filled with %RU64ms -- %RU8%%\n",
-                          pHstStream->szName, tsDeltaWrittenMs, cfGstWritten, DrvAudioHlpFramesToMs(cfGstWritten, &pHstStream->Cfg.Props),
-                          DrvAudioHlpFramesToMs(AudioMixBufUsed(&pHstStream->MixBuf), &pHstStream->Cfg.Props),
+                          pHstStream->szName, tsDeltaWrittenMs, cfGstWritten, DrvAudioHlpFramesToMilli(cfGstWritten, &pHstStream->Cfg.Props),
+                          DrvAudioHlpFramesToMilli(AudioMixBufUsed(&pHstStream->MixBuf), &pHstStream->Cfg.Props),
                           AudioMixBufUsed(&pHstStream->MixBuf) * 100 / AudioMixBufSize(&pHstStream->MixBuf)));
 
@@ -1599,5 +1599,5 @@
         Log3Func(("[%s] Buffer: Last played %RU64ms, filled with %RU64ms (%RU8%%) total, "
                   "(cfLive=%RU32, fThresholdReached=%RTbool)\n",
-                  pHstStream->szName, tsDeltaPlayedCapturedMs, DrvAudioHlpFramesToMs(cfLive, &pHstStream->Cfg.Props),
+                  pHstStream->szName, tsDeltaPlayedCapturedMs, DrvAudioHlpFramesToMilli(cfLive, &pHstStream->Cfg.Props),
                   uLivePercent, cfLive, pHstStream->fThresholdReached));
 #endif
@@ -1645,5 +1645,5 @@
                 cfToPlay = pHstStream->Cfg.Backend.cfPeriod;
             else
-                cfToPlay = DrvAudioHlpMsToFrames(tsDeltaPlayedCapturedMs, &pHstStream->Cfg.Props);
+                cfToPlay = DrvAudioHlpMilliToFrames(tsDeltaPlayedCapturedMs, &pHstStream->Cfg.Props);
 
             Log3Func(("[%s] Buffer: fJustStarted=%RTbool, cfLive=%RU32, cfToPlay=%RU32\n",
@@ -3254,10 +3254,10 @@
      */
     if (pDrvCfg->uPeriodMs)
-        pCfgReq->Backend.cfPeriod = DrvAudioHlpMsToFrames(pDrvCfg->uPeriodMs, &pCfgReq->Props);
+        pCfgReq->Backend.cfPeriod = DrvAudioHlpMilliToFrames(pDrvCfg->uPeriodMs, &pCfgReq->Props);
     else /* Set default period size. */
-        pCfgReq->Backend.cfPeriod = DrvAudioHlpMsToFrames(50 /* ms */, &pCfgReq->Props);
+        pCfgReq->Backend.cfPeriod = DrvAudioHlpMilliToFrames(50 /* ms */, &pCfgReq->Props);
 
     LogRel2(("Audio: Using %s period size (%RU32ms, %RU32 frames) for stream '%s'\n",
-             pDrvCfg->uPeriodMs ? "custom" : "default", DrvAudioHlpFramesToMs(pCfgReq->Backend.cfPeriod, &pCfgReq->Props),
+             pDrvCfg->uPeriodMs ? "custom" : "default", DrvAudioHlpFramesToMilli(pCfgReq->Backend.cfPeriod, &pCfgReq->Props),
              pCfgReq->Backend.cfPeriod, pHstStream->szName));
 
@@ -3266,10 +3266,10 @@
      */
     if (pDrvCfg->uBufferSizeMs)
-        pCfgReq->Backend.cfBufferSize = DrvAudioHlpMsToFrames(pDrvCfg->uBufferSizeMs, &pCfgReq->Props);
+        pCfgReq->Backend.cfBufferSize = DrvAudioHlpMilliToFrames(pDrvCfg->uBufferSizeMs, &pCfgReq->Props);
     else /* Set default buffer size. */
-        pCfgReq->Backend.cfBufferSize = DrvAudioHlpMsToFrames(200 /* ms */, &pCfgReq->Props);
+        pCfgReq->Backend.cfBufferSize = DrvAudioHlpMilliToFrames(200 /* ms */, &pCfgReq->Props);
 
     LogRel2(("Audio: Using %s buffer size (%RU32ms, %RU32 frames) for stream '%s'\n",
-             pDrvCfg->uBufferSizeMs ? "custom" : "default", DrvAudioHlpFramesToMs(pCfgReq->Backend.cfBufferSize, &pCfgReq->Props),
+             pDrvCfg->uBufferSizeMs ? "custom" : "default", DrvAudioHlpFramesToMilli(pCfgReq->Backend.cfBufferSize, &pCfgReq->Props),
              pCfgReq->Backend.cfBufferSize, pHstStream->szName));
 
@@ -3281,5 +3281,5 @@
         if (!pDrvCfg->uPreBufMs) /* Pre-buffering is set to disabled. */
             LogRel2(("Audio: Using custom pre-buffering (disabled) for stream '%s'\n", pHstStream->szName));
-        pCfgReq->Backend.cfPreBuf = DrvAudioHlpMsToFrames(pDrvCfg->uPreBufMs, &pCfgReq->Props);
+        pCfgReq->Backend.cfPreBuf = DrvAudioHlpMilliToFrames(pDrvCfg->uPreBufMs, &pCfgReq->Props);
     }
     else /* Set default pre-buffering size. */
@@ -3287,5 +3287,5 @@
 
     LogRel2(("Audio: Using %s pre-buffering size (%RU32ms, %RU32 frames) for stream '%s'\n",
-             pDrvCfg->uPreBufMs != UINT32_MAX ? "custom" : "default", DrvAudioHlpFramesToMs(pCfgReq->Backend.cfPreBuf, &pCfgReq->Props),
+             pDrvCfg->uPreBufMs != UINT32_MAX ? "custom" : "default", DrvAudioHlpFramesToMilli(pCfgReq->Backend.cfPreBuf, &pCfgReq->Props),
              pCfgReq->Backend.cfPreBuf, pHstStream->szName));
 
@@ -3296,6 +3296,6 @@
     {
         LogRel(("Audio: Error for stream '%s': Buffer size (%RU32ms) must not be smaller than the period size (%RU32ms)\n",
-                pHstStream->szName, DrvAudioHlpFramesToMs(pCfgReq->Backend.cfBufferSize, &pCfgReq->Props),
-                DrvAudioHlpFramesToMs(pCfgReq->Backend.cfPeriod, &pCfgReq->Props)));
+                pHstStream->szName, DrvAudioHlpFramesToMilli(pCfgReq->Backend.cfBufferSize, &pCfgReq->Props),
+                DrvAudioHlpFramesToMilli(pCfgReq->Backend.cfPeriod, &pCfgReq->Props)));
         return VERR_INVALID_PARAMETER;
     }
@@ -3307,6 +3307,6 @@
         {
             LogRel(("Audio: Error for stream '%s': Pre-buffering size (%RU32ms) must not be bigger than the buffer size (%RU32ms)\n",
-                    pHstStream->szName, DrvAudioHlpFramesToMs(pCfgReq->Backend.cfPreBuf, &pCfgReq->Props),
-                    DrvAudioHlpFramesToMs(pCfgReq->Backend.cfBufferSize, &pCfgReq->Props)));
+                    pHstStream->szName, DrvAudioHlpFramesToMilli(pCfgReq->Backend.cfPreBuf, &pCfgReq->Props),
+                    DrvAudioHlpFramesToMilli(pCfgReq->Backend.cfBufferSize, &pCfgReq->Props)));
             return VERR_INVALID_PARAMETER;
         }
@@ -3346,5 +3346,5 @@
     {
         LogRel2(("Audio: Custom buffer size overwritten by backend for stream '%s' (now %RU64ms, %RU32 frames)\n",
-                 pHstStream->szName, DrvAudioHlpFramesToMs(pCfgAcq->Backend.cfBufferSize, &pCfgAcq->Props), pCfgAcq->Backend.cfBufferSize));
+                 pHstStream->szName, DrvAudioHlpFramesToMilli(pCfgAcq->Backend.cfBufferSize, &pCfgAcq->Props), pCfgAcq->Backend.cfBufferSize));
     }
 
@@ -3353,5 +3353,5 @@
     {
         LogRel2(("Audio: Custom period size overwritten by backend for stream '%s' (now %RU64ms, %RU32 frames)\n",
-                 pHstStream->szName, DrvAudioHlpFramesToMs(pCfgAcq->Backend.cfPeriod, &pCfgAcq->Props), pCfgAcq->Backend.cfPeriod));
+                 pHstStream->szName, DrvAudioHlpFramesToMilli(pCfgAcq->Backend.cfPeriod, &pCfgAcq->Props), pCfgAcq->Backend.cfPeriod));
     }
 
@@ -3360,5 +3360,5 @@
     {
         LogRel2(("Audio: Custom pre-buffering size overwritten by backend for stream '%s' (now %RU64ms, %RU32 frames)\n",
-                 pHstStream->szName, DrvAudioHlpFramesToMs(pCfgAcq->Backend.cfPreBuf, &pCfgAcq->Props), pCfgAcq->Backend.cfPreBuf));
+                 pHstStream->szName, DrvAudioHlpFramesToMilli(pCfgAcq->Backend.cfPreBuf, &pCfgAcq->Props), pCfgAcq->Backend.cfPreBuf));
     }
 
Index: /trunk/src/VBox/Devices/Audio/DrvAudio.h
===================================================================
--- /trunk/src/VBox/Devices/Audio/DrvAudio.h	(revision 73407)
+++ /trunk/src/VBox/Devices/Audio/DrvAudio.h	(revision 73408)
@@ -187,12 +187,12 @@
 bool     DrvAudioHlpBytesIsAligned(uint32_t cbSize, const PPDMAUDIOPCMPROPS pProps);
 uint32_t DrvAudioHlpBytesToFrames(uint32_t cbBytes, const PPDMAUDIOPCMPROPS pProps);
-uint64_t DrvAudioHlpBytesToMs(uint32_t cbBytes, const PPDMAUDIOPCMPROPS pProps);
+uint64_t DrvAudioHlpBytesToMilli(uint32_t cbBytes, const PPDMAUDIOPCMPROPS pProps);
 uint64_t DrvAudioHlpBytesToNano(uint32_t cbBytes, const PPDMAUDIOPCMPROPS pProps);
 uint32_t DrvAudioHlpFramesToBytes(uint32_t cFrames, const PPDMAUDIOPCMPROPS pProps);
-uint64_t DrvAudioHlpFramesToMs(uint32_t cFrames, const PPDMAUDIOPCMPROPS pProps);
+uint64_t DrvAudioHlpFramesToMilli(uint32_t cFrames, const PPDMAUDIOPCMPROPS pProps);
 uint64_t DrvAudioHlpFramesToNano(uint32_t cFrames, const PPDMAUDIOPCMPROPS pProps);
-uint32_t DrvAudioHlpMsToBytes(uint32_t uMs, const PPDMAUDIOPCMPROPS pProps);
+uint32_t DrvAudioHlpMilliToBytes(uint32_t uMs, const PPDMAUDIOPCMPROPS pProps);
 uint32_t DrvAudioHlpNanoToBytes(uint32_t uNs, const PPDMAUDIOPCMPROPS pProps);
-uint32_t DrvAudioHlpMsToFrames(uint32_t uMs, const PPDMAUDIOPCMPROPS pProps);
+uint32_t DrvAudioHlpMilliToFrames(uint32_t uMs, const PPDMAUDIOPCMPROPS pProps);
 uint32_t DrvAudioHlpNanoToFrames(uint32_t uNs, const PPDMAUDIOPCMPROPS pProps);
 /** @}  */
Index: /trunk/src/VBox/Devices/Audio/DrvAudioCommon.cpp
===================================================================
--- /trunk/src/VBox/Devices/Audio/DrvAudioCommon.cpp	(revision 73407)
+++ /trunk/src/VBox/Devices/Audio/DrvAudioCommon.cpp	(revision 73408)
@@ -1120,5 +1120,5 @@
  * @param   pProps              PCM properties to calculate amount of bytes for.
  */
-uint64_t DrvAudioHlpBytesToMs(uint32_t cbBytes, const PPDMAUDIOPCMPROPS pProps)
+uint64_t DrvAudioHlpBytesToMilli(uint32_t cbBytes, const PPDMAUDIOPCMPROPS pProps)
 {
     AssertPtrReturn(pProps, 0);
@@ -1181,5 +1181,5 @@
  * @param   pProps              PCM properties to calculate time (in ms) for.
  */
-uint64_t DrvAudioHlpFramesToMs(uint32_t cFrames, const PPDMAUDIOPCMPROPS pProps)
+uint64_t DrvAudioHlpFramesToMilli(uint32_t cFrames, const PPDMAUDIOPCMPROPS pProps)
 {
     AssertPtrReturn(pProps, 0);
@@ -1221,5 +1221,5 @@
  * @param   pProps              PCM properties to calculate amount of bytes for.
  */
-uint32_t DrvAudioHlpMsToBytes(uint32_t uMs, const PPDMAUDIOPCMPROPS pProps)
+uint32_t DrvAudioHlpMilliToBytes(uint32_t uMs, const PPDMAUDIOPCMPROPS pProps)
 {
     AssertPtrReturn(pProps, 0);
@@ -1255,5 +1255,5 @@
  * @param   pProps              PCM properties to calculate amount of frames for.
  */
-uint32_t DrvAudioHlpMsToFrames(uint32_t uMs, const PPDMAUDIOPCMPROPS pProps)
+uint32_t DrvAudioHlpMilliToFrames(uint32_t uMs, const PPDMAUDIOPCMPROPS pProps)
 {
     AssertPtrReturn(pProps, 0);
@@ -1263,5 +1263,5 @@
         return 0;
 
-    return DrvAudioHlpMsToBytes(uMs, pProps) / cbFrame;
+    return DrvAudioHlpMilliToBytes(uMs, pProps) / cbFrame;
 }
 
Index: /trunk/src/VBox/Devices/Audio/DrvHostALSAAudio.cpp
===================================================================
--- /trunk/src/VBox/Devices/Audio/DrvHostALSAAudio.cpp	(revision 73407)
+++ /trunk/src/VBox/Devices/Audio/DrvHostALSAAudio.cpp	(revision 73408)
@@ -1290,5 +1290,5 @@
         req.freq        = pCfgReq->Props.uHz;
         req.nchannels   = pCfgReq->Props.cChannels;
-        req.period_size = DrvAudioHlpMsToFrames(50 /* ms */, &pCfgReq->Props); /** @todo Make this configurable. */
+        req.period_size = DrvAudioHlpMilliToFrames(50 /* ms */, &pCfgReq->Props); /** @todo Make this configurable. */
         req.buffer_size = req.period_size * 2; /** @todo Make this configurable. */
         req.threshold   = req.period_size;
Index: /trunk/src/VBox/Devices/Audio/DrvHostDSound.cpp
===================================================================
--- /trunk/src/VBox/Devices/Audio/DrvHostDSound.cpp	(revision 73407)
+++ /trunk/src/VBox/Devices/Audio/DrvHostDSound.cpp	(revision 73408)
@@ -677,5 +677,5 @@
 
         DSLOG(("DSound: Requested playback buffer is %RU64ms (%ld bytes)\n",
-               pCfgReq->Backend.cfBufferSize, DrvAudioHlpBytesToMs(bd.dwBufferBytes, &pCfgReq->Props), bd.dwBufferBytes));
+               pCfgReq->Backend.cfBufferSize, DrvAudioHlpBytesToMilli(bd.dwBufferBytes, &pCfgReq->Props), bd.dwBufferBytes));
 
         hr = IDirectSound8_CreateSoundBuffer(pThis->pDS, &bd, &pDSB, NULL);
@@ -719,5 +719,5 @@
 
         DSLOG(("DSound: Acquired playback buffer is %RU64ms (%ld bytes)\n",
-               DrvAudioHlpBytesToMs(bc.dwBufferBytes, &pCfgReq->Props), bc.dwBufferBytes));
+               DrvAudioHlpBytesToMilli(bc.dwBufferBytes, &pCfgReq->Props), bc.dwBufferBytes));
 
         DSLOG(("DSound: Acquired playback format:\n"
@@ -1361,5 +1361,5 @@
 
         DSLOG(("DSound: Requested capture buffer is %RU64ms (%ld bytes)\n",
-               pCfgReq->Backend.cfBufferSize, DrvAudioHlpBytesToMs(bd.dwBufferBytes, &pCfgReq->Props), bd.dwBufferBytes));
+               pCfgReq->Backend.cfBufferSize, DrvAudioHlpBytesToMilli(bd.dwBufferBytes, &pCfgReq->Props), bd.dwBufferBytes));
 
         LPDIRECTSOUNDCAPTUREBUFFER pDSCB;
@@ -1414,5 +1414,5 @@
 
         DSLOG(("DSound: Acquired capture buffer is %RU64ms (%ld bytes)\n",
-               DrvAudioHlpBytesToMs(bc.dwBufferBytes, &pCfgReq->Props), bc.dwBufferBytes));
+               DrvAudioHlpBytesToMilli(bc.dwBufferBytes, &pCfgReq->Props), bc.dwBufferBytes));
 
         DSLOG(("DSound: Capture format:\n"
@@ -2297,5 +2297,5 @@
         {
             const uint64_t diffLastTransferredMs  = RTTimeMilliTS() - pStreamDS->Out.tsLastTransferred;
-            const uint64_t uLastTranserredChunkMs = DrvAudioHlpBytesToMs(pStreamDS->Out.cbLastTransferred, &pStreamDS->Cfg.Props);
+            const uint64_t uLastTranserredChunkMs = DrvAudioHlpBytesToMilli(pStreamDS->Out.cbLastTransferred, &pStreamDS->Cfg.Props);
             if (   uLastTranserredChunkMs
                 && diffLastTransferredMs < uLastTranserredChunkMs)
Index: /trunk/src/VBox/Devices/Audio/HDAStream.cpp
===================================================================
--- /trunk/src/VBox/Devices/Audio/HDAStream.cpp	(revision 73407)
+++ /trunk/src/VBox/Devices/Audio/HDAStream.cpp	(revision 73408)
@@ -207,5 +207,5 @@
 
     /* By default we allocate an internal buffer of 100ms. */
-    rc = RTCircBufCreate(&pStream->State.pCircBuf, DrvAudioHlpMsToBytes(100 /* ms */, &pCfg->Props)); /** @todo Make this configurable. */
+    rc = RTCircBufCreate(&pStream->State.pCircBuf, DrvAudioHlpMilliToBytes(100 /* ms */, &pCfg->Props)); /** @todo Make this configurable. */
     AssertRCReturn(rc, rc);
 
Index: /trunk/src/VBox/Main/src-client/DrvAudioVRDE.cpp
===================================================================
--- /trunk/src/VBox/Main/src-client/DrvAudioVRDE.cpp	(revision 73407)
+++ /trunk/src/VBox/Main/src-client/DrvAudioVRDE.cpp	(revision 73408)
@@ -91,5 +91,5 @@
 
     /* According to the VRDP docs, the VRDP server stores audio in 200ms chunks. */
-    const uint32_t cfVRDPServer = DrvAudioHlpMsToFrames(200  /* ms */, &pCfgAcq->Props);
+    const uint32_t cfVRDPServer = DrvAudioHlpMilliToFrames(200  /* ms */, &pCfgAcq->Props);
 
     int rc = RTCircBufCreate(&pStreamVRDE->In.pCircBuf, DrvAudioHlpFramesToBytes(cfVRDPServer, &pCfgAcq->Props));
@@ -136,6 +136,6 @@
 
         /* According to the VRDP docs, the VRDP server stores audio in 200ms chunks. */
-        pCfgAcq->Backend.cfPeriod     = DrvAudioHlpMsToFrames(10  /* ms */, &pCfgAcq->Props);
-        pCfgAcq->Backend.cfBufferSize = DrvAudioHlpMsToFrames(200  /* ms */, &pCfgAcq->Props);
+        pCfgAcq->Backend.cfPeriod     = DrvAudioHlpMilliToFrames(10  /* ms */, &pCfgAcq->Props);
+        pCfgAcq->Backend.cfBufferSize = DrvAudioHlpMilliToFrames(200  /* ms */, &pCfgAcq->Props);
         pCfgAcq->Backend.cfPreBuf     = pCfgAcq->Backend.cfBufferSize;
     }
@@ -170,5 +170,5 @@
         {
             rc = pDrv->pConsoleVRDPServer->SendAudioInputBegin(NULL, pStreamVRDE,
-                                                               DrvAudioHlpMsToFrames(200 /* ms */, &pStreamVRDE->pCfg->Props),
+                                                               DrvAudioHlpMilliToFrames(200 /* ms */, &pStreamVRDE->pCfg->Props),
                                                                pStreamVRDE->pCfg->Props.uHz, pStreamVRDE->pCfg->Props.cChannels,
                                                                pStreamVRDE->pCfg->Props.cBits);
Index: /trunk/src/VBox/Main/src-client/DrvAudioVideoRec.cpp
===================================================================
--- /trunk/src/VBox/Main/src-client/DrvAudioVideoRec.cpp	(revision 73407)
+++ /trunk/src/VBox/Main/src-client/DrvAudioVideoRec.cpp	(revision 73408)
@@ -524,5 +524,5 @@
 
             /* Every Opus frame marks a period for now. Optimize this later. */
-            pCfgAcq->Backend.cfPeriod  = DrvAudioHlpMsToFrames(pSink->Codec.Opus.msFrame, &pCfgAcq->Props); /** @todo Make this configurable. */
+            pCfgAcq->Backend.cfPeriod  = DrvAudioHlpMilliToFrames(pSink->Codec.Opus.msFrame, &pCfgAcq->Props); /** @todo Make this configurable. */
         }
     }