Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManager.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManager.cpp	(revision 73456)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManager.cpp	(revision 73457)
@@ -629,5 +629,5 @@
 void UIVirtualBoxManager::sltOpenImportApplianceWizard(const QString &strFileName /* = QString() */)
 {
-    /* Show Import Appliance wizard: */
+    /* Initialize variables: */
 #ifdef VBOX_WS_MAC
     const QString strTmpFile = ::darwinResolveAlias(strFileName);
@@ -689,9 +689,6 @@
 void UIVirtualBoxManager::sltOpenPreferencesDialog()
 {
-    /* Check that we do NOT handling that already: */
-    if (actionPool()->action(UIActionIndex_M_Application_S_Preferences)->data().toBool())
-        return;
     /* Remember that we handling that already: */
-    actionPool()->action(UIActionIndex_M_Application_S_Preferences)->setData(true);
+    actionPool()->action(UIActionIndex_M_Application_S_Preferences)->setEnabled(false);
 
     /* Don't show the inaccessible warning
@@ -706,5 +703,5 @@
     /// @todo Is it possible at all if event-loop unwind?
     /* Remember that we do NOT handling that already: */
-    actionPool()->action(UIActionIndex_M_Application_S_Preferences)->setData(false);
+    actionPool()->action(UIActionIndex_M_Application_S_Preferences)->setEnabled(true);
 }
 
@@ -719,11 +716,13 @@
 #ifdef VBOX_WS_MAC
     QString strTmpFile = ::darwinResolveAlias(strFileName);
-#else /* VBOX_WS_MAC */
+#else
     QString strTmpFile = strFileName;
-#endif /* !VBOX_WS_MAC */
-    CVirtualBox vbox = vboxGlobal().virtualBox();
+#endif
+    CVirtualBox comVBox = vboxGlobal().virtualBox();
+
+    /* No file specified: */
     if (strTmpFile.isEmpty())
     {
-        QString strBaseFolder = vbox.GetSystemProperties().GetDefaultMachineFolder();
+        QString strBaseFolder = comVBox.GetSystemProperties().GetDefaultMachineFolder();
         QString strTitle = tr("Select a virtual machine file");
         QStringList extensions;
@@ -741,74 +740,26 @@
 
     /* Make sure this machine can be opened: */
-    CMachine newMachine = vbox.OpenMachine(strTmpFile);
-    if (!vbox.isOk())
-    {
-        msgCenter().cannotOpenMachine(vbox, strTmpFile);
+    CMachine comMachineNew = comVBox.OpenMachine(strTmpFile);
+    if (!comVBox.isOk())
+    {
+        msgCenter().cannotOpenMachine(comVBox, strTmpFile);
         return;
     }
 
     /* Make sure this machine was NOT registered already: */
-    CMachine oldMachine = vbox.FindMachine(newMachine.GetId());
-    if (!oldMachine.isNull())
-    {
-        msgCenter().cannotReregisterExistingMachine(strTmpFile, oldMachine.GetName());
+    CMachine comMachineOld = comVBox.FindMachine(comMachineNew.GetId());
+    if (!comMachineOld.isNull())
+    {
+        msgCenter().cannotReregisterExistingMachine(strTmpFile, comMachineOld.GetName());
         return;
     }
 
     /* Register that machine: */
-    vbox.RegisterMachine(newMachine);
-}
-
-void UIVirtualBoxManager::sltOpenMachineSettingsDialog(const QString &strCategoryRef /* = QString() */,
-                                                       const QString &strControlRef /* = QString() */,
+    comVBox.RegisterMachine(comMachineNew);
+}
+
+void UIVirtualBoxManager::sltOpenMachineSettingsDialog(QString strCategory /* = QString() */,
+                                                       QString strControl /* = QString() */,
                                                        const QString &strID /* = QString() */)
-{
-    /* This slot should not be called when there is not selection: */
-    AssertMsgReturnVoid(currentItem(), ("Current item should be selected!\n"));
-
-    /* Check that we do NOT handling that already: */
-    if (actionPool()->action(UIActionIndexST_M_Machine_S_Settings)->data().toBool())
-        return;
-    /* Remember that we handling that already: */
-    actionPool()->action(UIActionIndexST_M_Machine_S_Settings)->setData(true);
-
-    /* Process href from VM details / description: */
-    if (!strCategoryRef.isEmpty() && strCategoryRef[0] != '#')
-    {
-        vboxGlobal().openURL(strCategoryRef);
-        return;
-    }
-
-    /* Get category and control: */
-    QString strCategory = strCategoryRef;
-    QString strControl = strControlRef;
-    /* Check if control is coded into the URL by %%: */
-    if (strControl.isEmpty())
-    {
-        QStringList parts = strCategory.split("%%");
-        if (parts.size() == 2)
-        {
-            strCategory = parts.at(0);
-            strControl = parts.at(1);
-        }
-    }
-
-    /* Don't show the inaccessible warning
-     * if the user tries to open VM settings: */
-    m_fFirstMediumEnumerationHandled = true;
-
-    /* Create and execute corresponding VM settings window: */
-    QPointer<UISettingsDialogMachine> pDlg = new UISettingsDialogMachine(this,
-                                                                         QUuid(strID).isNull() ? currentItem()->id() : strID,
-                                                                         strCategory, strControl);
-    pDlg->execute();
-    delete pDlg;
-
-    /// @todo Is it possible at all if event-loop unwind?
-    /* Remember that we do NOT handling that already: */
-    actionPool()->action(UIActionIndexST_M_Machine_S_Settings)->setData(false);
-}
-
-void UIVirtualBoxManager::sltOpenCloneMachineWizard()
 {
     /* Get current item: */
@@ -817,11 +768,54 @@
 
     /* Lock the action preventing cascade calls: */
+    actionPool()->action(UIActionIndexST_M_Machine_S_Settings)->setEnabled(false);
+
+    /* Process href from VM details / description: */
+    if (!strCategory.isEmpty() && strCategory[0] != '#')
+    {
+        vboxGlobal().openURL(strCategory);
+    }
+    else
+    {
+        /* Check if control is coded into the URL by %%: */
+        if (strControl.isEmpty())
+        {
+            QStringList parts = strCategory.split("%%");
+            if (parts.size() == 2)
+            {
+                strCategory = parts.at(0);
+                strControl = parts.at(1);
+            }
+        }
+
+        /* Don't show the inaccessible warning
+         * if the user tries to open VM settings: */
+        m_fFirstMediumEnumerationHandled = true;
+
+        /* Create and execute corresponding VM settings window: */
+        QPointer<UISettingsDialogMachine> pDlg = new UISettingsDialogMachine(this,
+                                                                             QUuid(strID).isNull() ? pItem->id() : strID,
+                                                                             strCategory, strControl);
+        pDlg->execute();
+        delete pDlg;
+    }
+
+    /// @todo Is it possible at all if event-loop unwind?
+    /* Unlock the action allowing further calls: */
+    actionPool()->action(UIActionIndexST_M_Machine_S_Settings)->setEnabled(true);
+}
+
+void UIVirtualBoxManager::sltOpenCloneMachineWizard()
+{
+    /* Get current item: */
+    UIVirtualMachineItem *pItem = currentItem();
+    AssertMsgReturnVoid(pItem, ("Current item should be selected!\n"));
+
+    /* Lock the action preventing cascade calls: */
     actionPool()->action(UIActionIndexST_M_Machine_S_Clone)->setEnabled(false);
 
     /* Use the "safe way" to open stack of Mac OS X Sheets: */
     QWidget *pWizardParent = windowManager().realParentWindow(this);
-
     const QStringList &machineGroupNames = pItem->groups();
-    QString strGroup = !machineGroupNames.isEmpty() ? machineGroupNames.at(0) : QString();
+    const QString strGroup = !machineGroupNames.isEmpty() ? machineGroupNames.at(0) : QString();
     UISafePointerWizard pWizard = new UIWizardCloneVM(pWizardParent, pItem->machine(), strGroup);
     windowManager().registerNewParent(pWizard, pWizardParent);
@@ -835,6 +829,7 @@
 }
 
-void UIVirtualBoxManager::sltPerformMoveMachine()
-{
+void UIVirtualBoxManager::sltPerformMachineMove()
+{
+    /* Get current item: */
     UIVirtualMachineItem *pItem = currentItem();
     AssertMsgReturnVoid(pItem, ("Current item should be selected!\n"));
@@ -913,4 +908,5 @@
     QList<UIVirtualMachineItem*> itemsToDiscard;
     foreach (UIVirtualMachineItem *pItem, items)
+    {
         if (isActionEnabled(UIActionIndexST_M_Group_S_Discard, QList<UIVirtualMachineItem*>() << pItem))
         {
@@ -918,4 +914,5 @@
             itemsToDiscard << pItem;
         }
+    }
     AssertMsg(!machineNames.isEmpty(), ("This action should not be allowed!"));
 
@@ -928,16 +925,16 @@
     {
         /* Open a session to modify VM: */
-        CSession session = vboxGlobal().openSession(pItem->id());
-        if (session.isNull())
+        CSession comSession = vboxGlobal().openSession(pItem->id());
+        if (comSession.isNull())
             return;
 
         /* Get session machine: */
-        CMachine machine = session.GetMachine();
-        machine.DiscardSavedState(true);
-        if (!machine.isOk())
-            msgCenter().cannotDiscardSavedState(machine);
+        CMachine comMachine = comSession.GetMachine();
+        comMachine.DiscardSavedState(true);
+        if (!comMachine.isOk())
+            msgCenter().cannotDiscardSavedState(comMachine);
 
         /* Unlock machine finally: */
-        session.UnlockMachine();
+        comSession.UnlockMachine();
     }
 }
@@ -953,5 +950,5 @@
     {
         /* Get item state: */
-        KMachineState state = pItem->machineState();
+        const KMachineState enmState = pItem->machineState();
 
         /* Check if current item could be paused/resumed: */
@@ -961,38 +958,37 @@
         /* Check if current item already paused: */
         if (fPause &&
-            (state == KMachineState_Paused ||
-             state == KMachineState_TeleportingPausedVM))
+            (enmState == KMachineState_Paused ||
+             enmState == KMachineState_TeleportingPausedVM))
             continue;
 
         /* Check if current item already resumed: */
         if (!fPause &&
-            (state == KMachineState_Running ||
-             state == KMachineState_Teleporting ||
-             state == KMachineState_LiveSnapshotting))
+            (enmState == KMachineState_Running ||
+             enmState == KMachineState_Teleporting ||
+             enmState == KMachineState_LiveSnapshotting))
             continue;
 
         /* Open a session to modify VM state: */
-        CSession session = vboxGlobal().openExistingSession(pItem->id());
-        if (session.isNull())
+        CSession comSession = vboxGlobal().openExistingSession(pItem->id());
+        if (comSession.isNull())
             return;
 
         /* Get session console: */
-        CConsole console = session.GetConsole();
+        CConsole comConsole = comSession.GetConsole();
         /* Pause/resume VM: */
         if (fPause)
-            console.Pause();
+            comConsole.Pause();
         else
-            console.Resume();
-        bool ok = console.isOk();
-        if (!ok)
+            comConsole.Resume();
+        if (!comConsole.isOk())
         {
             if (fPause)
-                msgCenter().cannotPauseMachine(console);
+                msgCenter().cannotPauseMachine(comConsole);
             else
-                msgCenter().cannotResumeMachine(console);
+                msgCenter().cannotResumeMachine(comConsole);
         }
 
         /* Unlock machine finally: */
-        session.UnlockMachine();
+        comSession.UnlockMachine();
     }
 }
@@ -1008,4 +1004,5 @@
     QList<UIVirtualMachineItem*> itemsToReset;
     foreach (UIVirtualMachineItem *pItem, items)
+    {
         if (isActionEnabled(UIActionIndexST_M_Group_S_Reset, QList<UIVirtualMachineItem*>() << pItem))
         {
@@ -1013,4 +1010,5 @@
             itemsToReset << pItem;
         }
+    }
     AssertMsg(!machineNames.isEmpty(), ("This action should not be allowed!"));
 
@@ -1023,15 +1021,15 @@
     {
         /* Open a session to modify VM state: */
-        CSession session = vboxGlobal().openExistingSession(pItem->id());
-        if (session.isNull())
+        CSession comSession = vboxGlobal().openExistingSession(pItem->id());
+        if (comSession.isNull())
             return;
 
         /* Get session console: */
-        CConsole console = session.GetConsole();
+        CConsole comConsole = comSession.GetConsole();
         /* Reset VM: */
-        console.Reset();
+        comConsole.Reset();
 
         /* Unlock machine finally: */
-        session.UnlockMachine();
+        comSession.UnlockMachine();
     }
 }
@@ -1069,34 +1067,34 @@
 
         /* Open a session to modify VM state: */
-        CSession session = vboxGlobal().openExistingSession(pItem->id());
-        if (session.isNull())
+        CSession comSession = vboxGlobal().openExistingSession(pItem->id());
+        if (comSession.isNull())
             return;
 
         /* Get session console: */
-        CConsole console = session.GetConsole();
+        CConsole comConsole = comSession.GetConsole();
         /* Get session machine: */
-        CMachine machine = session.GetMachine();
+        CMachine comMachine = comSession.GetMachine();
         /* Pause VM first if necessary: */
         if (pItem->machineState() != KMachineState_Paused)
-            console.Pause();
-        if (console.isOk())
+            comConsole.Pause();
+        if (comConsole.isOk())
         {
             /* Prepare machine state saving progress: */
-            CProgress progress = machine.SaveState();
-            if (machine.isOk())
+            CProgress comProgress = comMachine.SaveState();
+            if (comMachine.isOk())
             {
                 /* Show machine state saving progress: */
-                msgCenter().showModalProgressDialog(progress, machine.GetName(), ":/progress_state_save_90px.png");
-                if (!progress.isOk() || progress.GetResultCode() != 0)
-                    msgCenter().cannotSaveMachineState(progress, machine.GetName());
+                msgCenter().showModalProgressDialog(comProgress, comMachine.GetName(), ":/progress_state_save_90px.png");
+                if (!comProgress.isOk() || comProgress.GetResultCode() != 0)
+                    msgCenter().cannotSaveMachineState(comProgress, comMachine.GetName());
             }
             else
-                msgCenter().cannotSaveMachineState(machine);
+                msgCenter().cannotSaveMachineState(comMachine);
         }
         else
-            msgCenter().cannotPauseMachine(console);
+            msgCenter().cannotPauseMachine(comConsole);
 
         /* Unlock machine finally: */
-        session.UnlockMachine();
+        comSession.UnlockMachine();
     }
 }
@@ -1112,4 +1110,5 @@
     QList<UIVirtualMachineItem*> itemsToShutdown;
     foreach (UIVirtualMachineItem *pItem, items)
+    {
         if (isActionEnabled(UIActionIndexST_M_Machine_M_Close_S_Shutdown, QList<UIVirtualMachineItem*>() << pItem))
         {
@@ -1117,4 +1116,5 @@
             itemsToShutdown << pItem;
         }
+    }
     AssertMsg(!machineNames.isEmpty(), ("This action should not be allowed!"));
 
@@ -1127,17 +1127,17 @@
     {
         /* Open a session to modify VM state: */
-        CSession session = vboxGlobal().openExistingSession(pItem->id());
-        if (session.isNull())
+        CSession comSession = vboxGlobal().openExistingSession(pItem->id());
+        if (comSession.isNull())
             return;
 
         /* Get session console: */
-        CConsole console = session.GetConsole();
+        CConsole comConsole = comSession.GetConsole();
         /* ACPI Shutdown: */
-        console.PowerButton();
-        if (!console.isOk())
-            msgCenter().cannotACPIShutdownMachine(console);
+        comConsole.PowerButton();
+        if (!comConsole.isOk())
+            msgCenter().cannotACPIShutdownMachine(comConsole);
 
         /* Unlock machine finally: */
-        session.UnlockMachine();
+        comSession.UnlockMachine();
     }
 }
@@ -1153,4 +1153,5 @@
     QList<UIVirtualMachineItem*> itemsToPowerOff;
     foreach (UIVirtualMachineItem *pItem, items)
+    {
         if (isActionEnabled(UIActionIndexST_M_Machine_M_Close_S_PowerOff, QList<UIVirtualMachineItem*>() << pItem))
         {
@@ -1158,4 +1159,5 @@
             itemsToPowerOff << pItem;
         }
+    }
     AssertMsg(!machineNames.isEmpty(), ("This action should not be allowed!"));
 
@@ -1168,25 +1170,25 @@
     {
         /* Open a session to modify VM state: */
-        CSession session = vboxGlobal().openExistingSession(pItem->id());
-        if (session.isNull())
+        CSession comSession = vboxGlobal().openExistingSession(pItem->id());
+        if (comSession.isNull())
             return;
 
         /* Get session console: */
-        CConsole console = session.GetConsole();
+        CConsole comConsole = comSession.GetConsole();
         /* Prepare machine power down: */
-        CProgress progress = console.PowerDown();
-        if (console.isOk())
+        CProgress comProgress = comConsole.PowerDown();
+        if (comConsole.isOk())
         {
             /* Show machine power down progress: */
-            CMachine machine = session.GetMachine();
-            msgCenter().showModalProgressDialog(progress, machine.GetName(), ":/progress_poweroff_90px.png");
-            if (!progress.isOk() || progress.GetResultCode() != 0)
-                msgCenter().cannotPowerDownMachine(progress, machine.GetName());
+            CMachine machine = comSession.GetMachine();
+            msgCenter().showModalProgressDialog(comProgress, machine.GetName(), ":/progress_poweroff_90px.png");
+            if (!comProgress.isOk() || comProgress.GetResultCode() != 0)
+                msgCenter().cannotPowerDownMachine(comProgress, machine.GetName());
         }
         else
-            msgCenter().cannotPowerDownMachine(console);
+            msgCenter().cannotPowerDownMachine(comConsole);
 
         /* Unlock machine finally: */
-        session.UnlockMachine();
+        comSession.UnlockMachine();
     }
 }
@@ -1241,7 +1243,6 @@
 void UIVirtualBoxManager::sltCloseLogViewerWindow()
 {
+    /* Search for the sender of the signal within the m_logViewers map: */
     QMap<QString, QIManagerDialog*>::iterator sendersIterator = m_logViewers.begin();
-
-    /* Search for the sender of the signal within the m_logViewers map: */
     while (sendersIterator != m_logViewers.end() && sendersIterator.value() != sender())
         ++sendersIterator;
@@ -1250,11 +1251,12 @@
         return;
 
-    QIManagerDialog* pDialog = qobject_cast<QIManagerDialog*>(sendersIterator.value());
+    /* Check whether we have found the proper dialog: */
+    QIManagerDialog *pDialog = qobject_cast<QIManagerDialog*>(sendersIterator.value());
     if (!pDialog)
         return;
 
-    /* First remove this log viewer dialog from the map. This should be
-       done before closing the dialog which will incur a second call to
-       this function and result in double delete!!!: */
+    /* First remove this log-viewer dialog from the map.
+     * This should be done before closing the dialog which will incur
+     * a second call to this function and result in double delete!!!: */
     m_logViewers.erase(sendersIterator);
     UIVMLogViewerDialogFactory(CMachine()).cleanup(pDialog);
@@ -1293,8 +1295,8 @@
 
         /* Create shortcut for this VM: */
-        const CMachine &machine = pItem->machine();
-        UIDesktopServices::createMachineShortcut(machine.GetSettingsFilePath(),
+        const CMachine &comMachine = pItem->machine();
+        UIDesktopServices::createMachineShortcut(comMachine.GetSettingsFilePath(),
                                                  QStandardPaths::writableLocation(QStandardPaths::DesktopLocation),
-                                                 machine.GetName(), machine.GetId());
+                                                 comMachine.GetName(), comMachine.GetId());
     }
 }
@@ -1413,5 +1415,5 @@
     /* We have to make sure that we are getting the front most process: */
     ::darwinSetFrontMostProcess();
-#endif /* VBOX_WS_MAC */
+#endif
 
     /* Cache medium data early if necessary: */
@@ -1458,5 +1460,5 @@
      * On Mac OS X the icon referenced in info.plist is used.
      * On X11 we will provide as much icons as we can. */
-#if !(defined (VBOX_WS_WIN) || defined (VBOX_WS_MAC))
+#if !defined(VBOX_WS_WIN) && !defined(VBOX_WS_MAC)
     QIcon icon(":/VirtualBox.svg");
     icon.addFile(":/VirtualBox_48px.png");
@@ -1505,5 +1507,5 @@
     menuBar()->addMenu(gpWindowMenuManager->createMenu(this));
     gpWindowMenuManager->addWindow(this);
-#endif /* VBOX_WS_MAC */
+#endif
 
     /* Prepare Help-menu: */
@@ -1523,4 +1525,5 @@
 
 #ifdef VBOX_WS_MAC
+
     /* 'About' action goes to Application menu: */
     pMenu->addAction(actionPool()->action(UIActionIndex_M_Application_S_About));
@@ -1607,4 +1610,5 @@
     /* 'Close' action goes to 'File' menu: */
     pMenu->addAction(actionPool()->action(UIActionIndexST_M_File_S_Close));
+
 #endif /* !VBOX_WS_MAC */
 }
@@ -2090,5 +2094,5 @@
     connect(actionPool()->action(UIActionIndexST_M_Machine_S_Settings), SIGNAL(triggered()), this, SLOT(sltOpenMachineSettingsDialog()));
     connect(actionPool()->action(UIActionIndexST_M_Machine_S_Clone), SIGNAL(triggered()), this, SLOT(sltOpenCloneMachineWizard()));
-    connect(actionPool()->action(UIActionIndexST_M_Machine_S_Move), SIGNAL(triggered()), this, SLOT(sltPerformMoveMachine()));
+    connect(actionPool()->action(UIActionIndexST_M_Machine_S_Move), SIGNAL(triggered()), this, SLOT(sltPerformMachineMove()));
     connect(actionPool()->action(UIActionIndexST_M_Machine_M_StartOrShow), SIGNAL(triggered()), this, SLOT(sltPerformStartOrShowMachine()));
     connect(actionPool()->action(UIActionIndexST_M_Machine_T_Pause), SIGNAL(toggled(bool)), this, SLOT(sltPerformPauseOrResumeMachine(bool)));
@@ -2268,5 +2272,5 @@
     /* Cleanup 'Window' menu: */
     UIWindowMenuManager::destroy();
-#endif /* VBOX_WS_MAC */
+#endif
 
     /* Destroy action-pool: */
@@ -2298,4 +2302,5 @@
     QList<UIVirtualMachineItem*> startableItems;
     foreach (UIVirtualMachineItem *pItem, items)
+    {
         if (isAtLeastOneItemCanBeStarted(QList<UIVirtualMachineItem*>() << pItem))
         {
@@ -2303,4 +2308,5 @@
             startableMachineNames << pItem->name();
         }
+    }
 
     /* Initially we have start auto-confirmed: */
@@ -2313,4 +2319,5 @@
     /* For every item => check if it could be launched: */
     foreach (UIVirtualMachineItem *pItem, items)
+    {
         if (   isAtLeastOneItemCanBeShown(QList<UIVirtualMachineItem*>() << pItem)
             || (   isAtLeastOneItemCanBeStarted(QList<UIVirtualMachineItem*>() << pItem)
@@ -2328,4 +2335,5 @@
             vboxGlobal().launchMachine(machine, enmItemLaunchMode);
         }
+    }
 }
 
@@ -2441,4 +2449,5 @@
     UIVirtualMachineItem *pFirstStartedAction = 0;
     foreach (UIVirtualMachineItem *pSelectedItem, items)
+    {
         if (UIVirtualMachineItem::isItemStarted(pSelectedItem))
         {
@@ -2446,4 +2455,5 @@
             break;
         }
+    }
     /* Update the group Pause/Resume action appearance: */
     actionPool()->action(UIActionIndexST_M_Group_T_Pause)->blockSignals(true);
@@ -2650,11 +2660,13 @@
 {
     foreach (UIVirtualMachineItem *pItem, items)
-        if (pItem->accessible()
+    {
+        if (   pItem->accessible()
 #ifdef VBOX_WS_MAC
             /* On Mac OS X this are real alias files, which don't work with the old legacy xml files. */
             && pItem->settingsFile().endsWith(".vbox", Qt::CaseInsensitive)
-#endif /* VBOX_WS_MAC */
+#endif
             )
             return true;
+    }
     return false;
 }
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManager.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManager.h	(revision 73456)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManager.h	(revision 73457)
@@ -181,6 +181,6 @@
           * @param strControl  can bring the widget of the page to focus.
           * @param strID       can bring the ID of machine to manage. */
-        void sltOpenMachineSettingsDialog(const QString &strCategory = QString(),
-                                          const QString &strControl = QString(),
+        void sltOpenMachineSettingsDialog(QString strCategory = QString(),
+                                          QString strControl = QString(),
                                           const QString &strID = QString());
 
@@ -189,5 +189,5 @@
 
         /** Handles the Move Machine action. */
-        void sltPerformMoveMachine();
+        void sltPerformMachineMove();
 
         /** Handles call to start or show machine. */